package models

import "gogs.mikescher.com/BlackForestBytes/goext/rfctime"

type SubscriptionType string //@enum:type

const (
	SubTypGroup    SubscriptionType = "GROUP"     // Subscribes to posts of a single group
	SubTypWholeOrg SubscriptionType = "WHOLE_ORG" // Subscribes to all posts of the org
)

type Subscription struct {
	SubscriptionID   SubscriptionID           `json:"id"               bson:"_id,omitempty"`
	CreationTime     rfctime.RFC3339NanoTime  `json:"creationTime"     bson:"creationTime"`
	UserID           AppUserID                `json:"userID"           bson:"userID"`
	SubscriptionType SubscriptionType         `json:"subscriptionType" bson:"subscriptionType"`
	OrganizationID   OrganizationID           `json:"organizationID"   bson:"organizationID"`
	Group            *GroupID                 `json:"groupID"          bson:"groupID"`
	Deleted          *rfctime.RFC3339NanoTime `json:"deleted"          bson:"deleted"`
}
